
# MODULE_NAME (required) and OTHER_* (optional) macros s/b defined by caller
SH_EXT		= .so
MODULE          = $(MODULE_NAME)-module$(SH_EXT)
GLUE            =  $(MODULE_NAME)_glue

PROFILE		= #-pg
CFLAGS		= -fPIC -g -Wall -O2 -fno-strength-reduce -fno-strict-aliasing -Wall $(OTHER_CFLAGS)
ELF_CC		= /usr/bin/gcc
ELF_CFLAGS	= $(PROFILE) $(CFLAGS) -fPIC -I/usr/include -I. -I../..
ELF_COMPILE	= $(ELF_CC) $(ELF_CFLAGS) $(OTHER_CFLAGS) -c
ELFLIB_MAJOR	= $(MODULE)

ELF_MAJOR_VERSION = 1
ELF_MINOR_VERSION = 0.0
ELF_LINK	= /usr/bin/gcc -shared -Wl,-soname#
ELF_LINK_FLAGS	= -shared -Wl,-soname#
ELF_DEP_LIBS	= $(DL_LIB) -lm -lc
ELF_LINK_CMD	= $(ELF_LINK),$(ELFLIB_MAJOR) $(ELF_DEP_LIBS)
DL_LIB		= -ldl

CXX		= g++
CXXFLAGS	= $(PROFILE) $(CFLAGS) -fPIC -I/usr/include -I.
CXX_COMPILE	= $(CXX) $(CXXFLAGS) -c
CXX_ELF_LINK	= $(CXX) -shared -Wl,-soname#
CXX_ELF_LINK_CMD= $(CXX_ELF_LINK),$(ELFLIB_MAJOR)
CXX_LIBS	= 

SLIRPROOT	= ../..
SLIRPSCRIPT	= $(SLIRPROOT)/slirp.sl
SLSH_EXE	= $(SLIRPROOT)/slsh
SLSH		= $(SLIRPROOT)/safe_slsh $(SLSH_EXE) -n
SLIRP_DEBUG	=
SLIRP		= $(SLSH) $(SLIRPSCRIPT) $(SLIRP_DEBUG)
DIFF		= diff 

SLANG_VERSION	= 20006
SLANGLIB	= -Wl,-R/usr/lib -L/usr/lib -lslang

FC		= f95
FCFLAGS		= -fPIC -g -O2
FCLIBS		= -Wl,-R/usr/lib/gcc/m68k-linux-gnu/4.1.2:/usr/lib/gcc/m68k-linux-gnu/4.1.2/../../..  -L/usr/lib/gcc/m68k-linux-gnu/4.1.2 -L/usr/lib/gcc/m68k-linux-gnu/4.1.2/../../.. -lgfortranbegin -lgfortran -lm -lgcc_s
FCLIBS_NAMES	=  -lgfortranbegin -lgfortran -lm -lgcc_s
FORTRAN_COMPILE = $(FC) $(FCFLAGS) -c
FORTRAN_LINK	= $(FC)

RM		= \rm -f
CP		= \cp

all: $(PRE_ALL) $(SLSH_EXE) $(MODULE) $(OTHER_ALL)

.SUFFIXES: .cc .f

.c.o:
	$(ELF_COMPILE) -c $< -o $@
.cc.o:
	$(CXX_COMPILE) $< -o $@
.f.o:
	$(FORTRAN_COMPILE) $?

clean:
	$(RM) *.o *$(SH_EXT) *~ $(GLUE).c $(OTHER_CLEAN) errs.msg

distclean: clean
	$(RM) $(OTHER_DISTCLEAN)

# This is intended for internal development use only
WARN_PROTO=-Wstrict-prototypes
WARN_NEX=-Wnested-externs
WARN_LLONG=-Wno-long-long
warnings:
	$(RM) $(GLUE).o
	@echo
	-CFLAGS="-Wall -W -pedantic -Winline -Wmissing-prototypes \
		-I/usr/include  -I. \
		$(WARN_NEX) -Wpointer-arith -Wcast-align -Wshadow \
	    $(WARN_PROTO) $(WARN_LLONG) " ; export CFLAGS ; \
	$(MAKE) -e $(GLUE).o > /dev/null 2> errs.msg
	@if [ -s errs.msg ] ; then \
	   cat errs.msg ; \
	   false ; \
	fi

$(SLSH_EXE):
	@if [ ! -x $(SLSH_EXE) ] ; then \
	   (cd $(SLIRPROOT) ; $(MAKE) slsh) ; \
	   if [ ! -x $(SLSH_EXE) ] ; then \
		echo "Cannot find/build $(SLSH_EXE)." ; \
		false; \
	   fi ; \
	fi
	@echo 
